<?php

namespace App\Policies;

use App\Domain\Complaints\Models\CommentComplaint;
use App\Models\User;
use Illuminate\Auth\Access\HandlesAuthorization;

class CommentComplaintPolicy
{
    use HandlesAuthorization;

    public function before(User $user)
    {
        if ($user->hasRole('administrators')) {
            return true;
        }
    }

    /**
     * Determine whether the user can view any models.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function viewAny(User $user)
    {
        if ($user->hasRole('moderator')) {
            return true;
        }
    }

    /**
     * Determine whether the user can view the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Domain\Complaints\Models\CommentComplaint  $commentComplaint
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function view(User $user, CommentComplaint $commentComplaint)
    {
        if ($user->hasRole('moderator')) {
            return true;
        }
    }

    /**
     * Determine whether the user can create models.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function create(User $user)
    {
        return false;
    }

    /**
     * Determine whether the user can update the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Domain\Complaints\Models\CommentComplaint  $commentComplaint
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function update(User $user, CommentComplaint $commentComplaint)
    {
        if ($user->hasRole('moderator')) {
            return true;
        }
    }

    /**
     * Determine whether the user can delete the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Domain\Complaints\Models\CommentComplaint  $commentComplaint
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function delete(User $user, CommentComplaint $commentComplaint)
    {
        return false;
    }

    /**
     * Determine whether the user can restore the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Domain\Complaints\Models\CommentComplaint  $commentComplaint
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function restore(User $user, CommentComplaint $commentComplaint)
    {
        //
    }

    /**
     * Determine whether the user can permanently delete the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Domain\Complaints\Models\CommentComplaint  $commentComplaint
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function forceDelete(User $user, CommentComplaint $commentComplaint)
    {
        //
    }
}
